Subject: Re: [Diffserv] diffserv MIB counts

From: Fred Baker <[email-masked]>
Date: Fri, 28 Sep 2001 13:43:07 -0700

At 12:59 PM 9/28/2001, Shahram Davari wrote:
>According to diffserv MIB, should the green, yellow and red packets be 
>counted individually? Also should they be counted both before and after 
>metering?

The Meter or the classifier (depending on where this is implemented) 
divides them into green, yellow, an red sub-aggregates, and lets you put 
count actions in line. The functional data paths then go through a random 
drop action, which might apply differing min-threshold and max-threshold 
values to the queue, and dumps them into the same queue. 

_______________________________________________
diffserv mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/diffserv
Archive: http://www2.ietf.org/mail-archive/working-groups/diffserv/current/maillist.html

---

From: Shahram Davari <[email-masked]>
Date: Fri, 28 Sep 2001 14:19:55 -0700

Hi Fred,

Can we conclude that a count action can be placed almost anywhere (in line)?

Yours,
-Shahram

> -----Original Message-----
> From: Fred Baker [mailto:[email-masked]]
> Sent: Friday, September 28, 2001 4:43 PM
> To: Shahram Davari
> Cc: [email-masked]'
> Subject: Re: [Diffserv] diffserv MIB counts
> 
>

---

From: Fred Baker <[email-masked]>
Date: Fri, 28 Sep 2001 14:49:07 -0700

I'm going to have some comments separated by pictures. Don't read a 
paragraph, see the start of a picture, and assume you have the substance of 
the note. There's a test at the end :^)

>Can we conclude that a count action can be placed almost anywhere (in line)?

yes, anywhere it makes sense. In context, I think you have a pretty simple 
picture, one of the following two. I think if you change them in any way, 
you get a mess; classification has to come before counting, and queuing has 
to come after. Discarding has to also come after counting and before 
queuing, because you want the packet presented to be in the total counter, 
but to potentially not get into the queue.

         +-----------------------------------------------------+
         |                     Classifier                      |
         +--------+-----------------+-----------------+--------+
                  | Green           | Yellow          | Red
                  |                 |                 |
             +----+----+       +----+----+       +----+----+
             |  Count  |       |  Count  |       |  Count  |
             |  Action |       |  Action |       |  Action |
             +----+----+       +----+----+       +----+----+
                  |                 |                 |
             +----+----+       +----+----+       +----+----+
             |  Random |       |  Random |       |  Random |
             |  Drop   |       |  Drop   |       |  Drop   |
             |  Action |       |  Action |       |  Action |
             +----+----+       +----+----+       +----+----+
                  |                 |                 |
         +--------+-----------------+-----------------+--------+
         |                        Queue                        |
         +--------------------------+--------------------------+
                                    |
                               +----+----+
                               |  Count  |
                               |  Action |
                               +----+----+
                                    |

         +-----------------------------------------------------+
         |                     Classifier                      |
         +--------+--------------------------------------------+
                  |Green| Yellow| Red
                  |     |       |
               +--+-----+-------+--+ Fail +--------------------+
               |      Meter        +------+      Meter         |
               +--+----------------+      +---+-------+--------+
                  | Succeed (Green)           |       |Fail (Red)
                  |                 +---------+       |
                  |                 | Succeed (Yellow)|
             +----+----+       +----+----+       +----+----+
             |  Count  |       |  Count  |       |  Count  |
             |  Action |       |  Action |       |  Action |
             +----+----+       +----+----+       +----+----+
                  |                 |                 |
             +----+----+       +----+----+       +----+----+
             |  Random |       |  Random |       |  Random |
             |  Drop   |       |  Drop   |       |  Drop   |
             |  Action |       |  Action |       |  Action |
             +----+----+       +----+----+       +----+----+
                  |                 |                 |
         +--------+-----------------+-----------------+--------+
         |                        Queue                        |
         +--------------------------+--------------------------+
                                    |
                               +----+----+
                               |  Count  |
                               |  Action |
                               +----+----+
                                    |

Now, this is slightly more explicit than the picture on page 23 in the MIB, 
because I ran out of bits to do ASCII Art in. That picture is:

          +-----------------------+
          | diffServDataPathStart |
          +-----------+-----------+
                      |
           +----------+
           |
        +--+--+     +-----+     +-----+     +-----+     +-----+
        | AF1 +-----+ AF2 +-----+ AF3 +-----+ AF4 +-----+ EF  |
        +-+++-+     +-+++-+     +-+++-+     +-+++-+     +-+-+-+
          |||         |||         |||         |||         | |
        +-+++-+     +-+++-+     +-+++-+     +-+++-+     +-+-+-+
        |trTCM|     |trTCM|     |trTCM|     |trTCM|     |srTCM|
        |Meter|     |Meter|     |Meter|     |Meter|     |Meter|
        +-+++-+     +-+++-+     +-+++-+     +-+++-+     +-+-+-+
          |||         |||         |||         |||         | |
        +-+||---+   +-+||---+   +-+||---+   +-+||---+   +-+-|---+
        |+-+|----+  |+-+|----+  |+-+|----+  |+-+|----+  |+--+----+
        ||+-+-----+ ||+-+-----+ ||+-+-----+ ||+-+-----+ ||Actions|
        +||Actions| +||Actions| +||Actions| +||Actions| +|       |
         +|       |  +|       |  +|       |  +|       |  +-+-----+
          +-+-----+   +-+-----+   +-+-----+   +-+-----+    |
          |||         |||         |||         |||          |
        +-+++--+    +-+++--+    +-+++--+    +-+++--+    +--+---+
        | Queue|    | Queue|    | Queue|    | Queue|    | Queue|
        +--+---+    +--+---+    +--+---+    +--+---+    +--+---+
           |           |           |           |           |
        +--+-----------+-----------+-----------+---+       |
        |     WFQ/WRR Scheduler                    |       |
        +--------------------------------------+---+       |
                                               |           |
                                         +-----+-----------+----+
                                         |  Priority Scheduler  |
                                         +----------+-----------+
                                                    |
                                                    V

        Figure 8: combined EF and AF implementation

The problem I have at this point is that I thought this was all covered in 
section 3.6.1 of the document; I believe it is verbally, but it sounds like 
it didn't make sense to you, or at least that the picture might have 
helped. Would it help you if I took the two pictures above, and a corollary 
picture for EF, and added them somewhere in that section?